This service will be undergoing maintenance at 00:00 UTC, 2017-10-23 It is expected to last about 30 minutes
Bug 500462 - ath5k 18 MB/s max rate
ath5k 18 MB/s max rate
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
11
i686 Linux
low Severity medium
: ---
: ---
Assigned To: Michal Schmidt
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-05-12 15:39 EDT by Jacek Pawlyta
Modified: 2010-06-28 08:30 EDT (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-06-28 08:30:51 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Jacek Pawlyta 2009-05-12 15:39:21 EDT
Description of problem:
ath5k kernel module gets max 18 MB/s speed on 100% quality link,
madwifi works on 54 MB/s 

Version-Release number of selected component (if applicable):
kernel: 2.6.29.3-60.fc10.i686

How reproducible:
Always

Steps to Reproduce:
1. start networkmanager
2. check connection rate 
  
Actual results:
18 MB/s

Expected results:
54 MB/s 

Additional info:
pcmcia wifi card

>lspci -vv

Adapter
  06:00.0 Ethernet controller: Atheros Communications Inc. Atheros AR5001X+ Wireless Network Adapter (rev 01)
        Subsystem: Atheros Communications Inc. TRENDnet TEW-443PI Wireless PCI Adapter
        Control: I/O- Mem+ BusMaster+ SpecCycle- MemWINV- VGASnoop- ParErr- Stepping- SERR- FastB2B- DisINTx-
        Status: Cap+ 66MHz- UDF- FastB2B+ ParErr- DEVSEL=medium >TAbort- <TAbort- <MAbort- >SERR- <PERR- INTx-
        Latency: 168 (2500ns min, 7000ns max), Cache Line Size: 128 bytes
        Interrupt: pin A routed to IRQ 16
        Region 0: Memory at 50000000 (32-bit, non-prefetchable) [size=64K]
        Capabilities: [44] Power Management version 2
                Flags: PMEClk- DSI- D1- D2- AuxCurrent=375mA PME(D0-,D1-,D2-,D3hot-,D3cold-)
                Status: D0 PME-Enable- DSel=0 DScale=2 PME-
        Kernel driver in use: ath5k
        Kernel modules: ath5k

>iwconfig
wlan0     IEEE 802.11bg  ESSID:"t"
          Mode:Managed  Frequency:2.437 GHz  Access Point: 00:
          Bit Rate=18 Mb/s   Tx-Power=27 dBm
          Retry min limit:7   RTS thr:off   Fragment thr=2352 B
          Encryption key: [2]   Security mode:open
          Power Management:off
          Link Quality=100/100  Signal level:-54 dBm  Noise level=-91 dBm
          Rx invalid nwid:0  Rx invalid crypt:0  Rx invalid frag:0
          Tx excessive retries:0  Invalid misc:0   Missed beacon:0

>ifconfig
wlan0     Link encap:Ethernet  HWaddr 
          inet addr:1  Bcast:1  Mask:255.255.255.0
          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1
          RX packets:590589 errors:0 dropped:0 overruns:0 frame:0
          TX packets:418998 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:1000
          RX bytes:660203457 (629.6 MiB)  TX bytes:66231582 (63.1 MiB)
Comment 1 John W. Linville 2009-05-12 15:48:20 EDT
Please show me a comparison that measures actual throughput, not simply the output of iwconfig (which only reports the speed used for the last packet).
Comment 2 Jacek Pawlyta 2009-05-12 16:03:35 EDT
Any suggestions how to do it? Would you like me to make the download or something and show the dl speed for ath5k and madwifi?
Comment 3 Jacek Pawlyta 2009-05-12 16:04:08 EDT
(In reply to comment #1)
> Please show me a comparison that measures actual throughput, not simply the
> output of iwconfig (which only reports the speed used for the last packet).  

Any suggestions how to do it? Would you like me to make the download or
something and show the dl speed for ath5k and madwifi?
Comment 4 John W. Linville 2009-05-13 09:19:45 EDT
Sure, it need not be too complex.  Something like this should suffice:

   time wget http://www.mywebsite.com/somewhat-big-file.tar.gz

The file should be big enough to be interesting, perhaps dozens or hundreds of megabytes.  If possible, you may want to do several runs just to account for any network anomalies.

It is certainly possible that madwifi could perform better (even significantly better) than ath5k.  But, considering that the same person implemented the rate scaling algorithms used by both drivers...well, it is better to measure.
Comment 5 Jacek Pawlyta 2009-05-13 13:35:00 EDT
here you are, the measurements results:

module ath5k  as above
***************
>time wget http://serwer/temp/file_126MB
--2009-05-13 18:32:46--  http://serwer/temp/file_126MB
2009-05-13 18:41:43 (241 KB/s) - `file_126MB' saved [132571718/132571718]
real    8m57.735s
user    0m0.395s
sys     0m2.487s

>time wget http://serwer/temp/file_126MB
--2009-05-13 18:45:06--  http://serwer/temp/file_126MB
2009-05-13 18:50:54 (372 KB/s) - `file_126MB.1' saved [132571718/132571718]
real    5m48.238s
user    0m0.359s
sys     0m2.413s

>time wget http://serwer/temp/file_126MB
--2009-05-13 18:51:27--  http://serwer/temp/file_126MB
2009-05-13 18:56:15 (450 KB/s) - `file_126MB.2' saved [132571718/132571718]
real    4m48.060s
user    0m0.320s
sys     0m2.374s


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5


madwifi-trunk-r4022-20090513
module ath_pci
****************
wlan0     IEEE 802.11g  ESSID:""  Nickname:""
          Mode:Managed  Frequency:2.437 GHz  Access Point: 00
          Bit Rate:54 Mb/s   Tx-Power:16 dBm   Sensitivity=1/1
          Retry:off   RTS thr:off   Fragment thr:off
          Encryption key:   Security mode:restricted
          Power Management:off
          Link Quality=31/70  Signal level=-65 dBm  Noise level=-96 dBm
          Rx invalid nwid:246  Rx invalid crypt:0  Rx invalid frag:0
          Tx excessive retries:0  Invalid misc:0   Missed beacon:0

>time wget http://serwer/temp/file_126MB
--2009-05-13 19:24:51--  http://serwer/temp/file_126MB
2009-05-13 19:26:03 (1.74 MB/s) - `file_126MB.3' saved [132571718/132571718]
real    1m12.964s
user    0m0.248s
sys     0m2.766s

>time wget http://serwer/temp/file_126MB
--2009-05-13 19:28:16--  http://serwer/temp/file_126MB
2009-05-13 19:29:38 (1.54 MB/s) - `file_126MB' saved [132571718/132571718]
real    1m22.558s
user    0m0.246s
sys     0m2.490s
Comment 6 John W. Linville 2009-05-13 13:53:10 EDT
Awesome, thanks!  Now, can you try ath5k again after this command?

   iwconfig wlan0 rate 54M

How does that perform?
Comment 7 Jacek Pawlyta 2009-05-13 14:22:19 EDT
>iwconfig wlan0 rate 54M
ping serwer
From 1 icmp_seq=1 Destination Host Unreachable

the highest rate when connection works is 24M, but then I have massive packet loss:
13 packets transmitted, 8 received, 38% packet loss, time 12649ms
rtt min/avg/max/mdev = 12.503/240.122/1451.773/460.172 ms, pipe 2

>iwconfig wlan0 rate auto
sets the rate to 18Mb/s
Comment 8 John W. Linville 2009-05-13 14:33:45 EDT
Ok, this is good information.  My first guess would be that your transmission power is not getting set as high with ath5k as with madwifi, or perhaps some other calibration or antenna configuration is poorly done for your device.  Hopefully Bob will have some ideas, as he is more familiar with the internals of the ath5k driver.
Comment 9 Jacek Pawlyta 2009-05-13 14:54:42 EDT
The strange thing is that ath5k behaves better on poorer signal than madwifi. At 40% signal level it still keeps 18M rate while madwifi goes down to 1-2 M.
Comment 10 Bob Copeland 2009-05-13 15:53:31 EDT
I agree it is likely a tx power issue.  2.6.31 got some work in this area,
commit 7c9889f1 in wireless-testing e.g. is a likely candidate.  Another thing
to try is changing "AR5K_TUNE_DEFAULT_TXPOWER" which defaults to 12.5 dBm
(25/2) -- madwifi seems to be using twice that power level above.

The signal level reported by the driver is unlikely to be directly comparable to madwifi (i.e. I bet ath5k lies somewhat).
Comment 11 Jacek Pawlyta 2009-05-13 16:52:52 EDT
Actually, in the ath5k.h we have:

#define AR5K_TUNE_MAX_TXPOWER                   60
#define AR5K_TUNE_DEFAULT_TXPOWER               30

kernel: 2.6.29.3-60.fc10.i686
Comment 12 Bug Zapper 2009-06-09 11:42:38 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 11 development cycle.
Changing version to '11'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 13 Bug Zapper 2010-04-27 10:17:58 EDT
This message is a reminder that Fedora 11 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 11.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '11'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 11's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 11 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 14 Bug Zapper 2010-06-28 08:30:51 EDT
Fedora 11 changed to end-of-life (EOL) status on 2010-06-25. Fedora 11 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.